{$MODE OBJFPC}
Unit MyStream;

Interface
uses classes;

type
  TMyFileStream = class(TStream)
  public
    constructor create(fn:string; mode: word);
    function Read(var Buffer; Count: LongInt):LongInt; override;
    function Write(const Buffer; Count: LongInt):LongInt; override;
    function Seek(Offset: LongInt; Origin: Word):LongInt; override;
    destructor destroy; override;
  protected
    procedure SetSize(newsize: Integer); override;
  private
    f:file;
end;

implementation

constructor TMyFileStream.create(fn:string; mode: word);
begin
  inherited create;
  assignfile(f,fn); // добавлено
  case mode of
    fmCreate: rewrite(f, 1);
    fmOpenreadwrite: reset(f, 1);
    else reset(f, 1); // добавлено
  end;
end;

destructor TMyFileStream.destroy();
begin
  closefile(f);
end;

function TMyFileStream.Read(var Buffer; Count: LongInt):LongInt;
begin
  blockread(f,buffer,count,result);
end;

function TMyFileStream.Write(const Buffer; Count: LongInt):LongInt;
begin
  blockwrite(f,buffer,count,result);
end;

function TMyFileStream.Seek(Offset: LongInt; Origin: Word):LongInt;
begin
 case origin of
   0: result:=0;
   1: result:=filepos(f);
   2: result:=filesize(f);
 end;
 inc(result, offset);
 system.seek(f, result);
 result:=filepos(f);
end;

procedure TMyFileStream.setsize(newsize:integer);
begin
 system.seek(f, newsize);
 truncate(f);
end;

end.